// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "RayTester3D.hpp"
#include "scene/Scene.hpp"

using namespace Dawn;

RayTester3D::RayTester3D(SceneItem *item) : SceneItemComponent(item) {

}

void RayTester3D::onStart() {
  this->getScene()->eventSceneUpdate.addListener(this, &RayTester3D::onUpdate);
}

void RayTester3D::onUpdate() {
  prefab->transform.setLocalPosition(glm::vec3(0, 0, 0));
  
  triangle.v0 = glm::vec3(-0.5f, -0.5f, 0);
  triangle.v1 = glm::vec3(0.5f, -0.5f, 0);
  triangle.v2 = glm::vec3(0, 0.5f, 0);

  auto mouse = this->getGame()->inputManager.getAxis2D(INPUT_BIND_MOUSE_X, INPUT_BIND_MOUSE_Y);
  mouse *= 2.0f;
  mouse -= glm::vec2(1, 1);

  glm::vec3 pos = glm::vec3(mouse.x * camera->orthoRight, mouse.y * camera->orthoBottom, 0.0f);
  ray.direction = glm::vec3(0, 0, -15);
  ray.origin = pos;

  // prefab->transform.setLocalPosition(pos);
  // ray.origin = glm::vec3(0, 0, 5);

  bool_t x = raytestTriangle(ray, triangle, &hit, &normal, &distance);

  if(x) {
    prefab->material->color = COLOR_RED;
  } else {
    prefab->material->color = COLOR_WHITE;
  }
}