// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/SceneItemComponent.hpp"
#include "prefabs/SimpleSpinningCubePrefab.hpp"
#include "physics/3d/Ray3D.hpp"
#include "scene/components/display/Camera.hpp"

namespace Dawn {
  class RayTester3D : public SceneItemComponent {
    public:
      SimpleSpinningCubePrefab *prefab;
      Camera *camera;
      struct PhysicsTriangle triangle;
      struct Ray3D ray;
      glm::vec3 hit;
      glm::vec3 normal;
      float_t distance;

      RayTester3D(SceneItem *item);
      void onStart() override;
      void onUpdate();
  };
}